C ARMSTRONG FLUX SOURCE
C MATTHEW PARNELL <M.PARNELL@LANCASTER.AC.UK>

      SUBROUTINE SOURCE(NOMORE)

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
      INCLUDE '(BEAMCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(IOIOCM)'
      INCLUDE '(LTCLCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(SOURCM)'
      INCLUDE '(SUMCOU)'

      LOGICAL LFIRST

      SAVE LFIRST
      DATA LFIRST /.TRUE./

C ENERGIES
      DOUBLE PRECISION EMIN, EMAX, RANDE
C ARMSTRONG FLUX PARAMETERS
      DOUBLE PRECISION PHIZ1, PHIZ2, SLOP1, SLOP2
      DOUBLE PRECISION NPARAM1, NPARAM2
      DOUBLE PRECISION P2FAC, PFAC2SL, PFAC2INT
      DOUBLE PRECISION PPRARM
C ARMSTRONG FLUX
      DOUBLE PRECISION COSSPC

      NOMORE = 0

C FIRST CALL INITIALISATIONS
      IF (LFIRST) THEN
C THE FOLLOWING 3 CARDS ARE MANDITORY
          TKESUM = ZERZER
          LFIRST = .FALSE.
          LUSSRC = .TRUE.
          WRITE(LUNOUT, *) 'ARMSTRONG FLUX SOURCE, ',
     +                     'BY MATTHEW PARNELL'
      ENDIF

C PUSH ONE SOURCE PARTICLE TO THE STACK
C IJBEAM IS THE TYPE SET BY THE BEAM CARD
      NPFLKA = NPFLKA + 1
      WRITE(LUNOUT, *) ' FLUKA PARTICLE NUM ', IJBEAM

C (RADIOACTIVE) ISOTOPE:
      IF (IJBEAM .EQ. -2 .AND. LRDBEA) THEN
          IARES  = IPROA
          IZRES  = IPROZ
          IISRES = IPROM
          CALL STISBM(IARES, IZRES, IISRES)
          IJHION = IPROZ  * 1000 + IPROA
          IJHION = IJHION * 100 + KXHEAV
          IONID  = IJHION
          CALL DCDION(IONID)
          CALL SETION(IONID)

C HEAVY ION:
      ELSEIF (IJBEAM .EQ. -2) THEN
          IJHION = IPROZ  * 1000 + IPROA
          IJHION = IJHION * 100 + KXHEAV
          IONID  = IJHION
          CALL DCDION(IONID)
          CALL SETION(IONID)
          ILOFLK(NPFLKA) = IJHION

C FLAG THIS IS PROMPT RADIATION
          LRADDC(NPFLKA) = .FALSE.
C GROUP NUMBER FOR "LOW" ENERGY NEUTRONS, SET TO 0 ANYWAY
          IGROUP(NPFLKA) = 0

C NORMAL HADRON:
      ELSE
          IONID = IJBEAM
          ILOFLK(NPFLKA) = IJBEAM
C FLAG THIS IS PROMPT RADIATION
          LRADDC(NPFLKA) = .FALSE.
C GROUP NUMBER FOR "LOW" ENERGY NEUTRONS, SET TO 0 ANYWAY
          IGROUP(NPFLKA) = 0
      ENDIF

C ====< DO NOT CHANGE FROM HERE >====

C PARTICLE GENERATION (1 FOR PRIMARIES)
      LOFLK(NPFLKA) = 1
C USER DEPENDENT FLAG:
      LOUSE(NPFLKA) = 0
C NO CHANNELLING:
      LCHFLK(NPFLKA) = .FALSE.
      DCHFLK(NPFLKA) = ZERZER
C USER DEPENDENT SPARE VARIABLES:
      DO 100 ISPR = 1, MKBMX1
          SPAREK(ISPR, NPFLKA) = ZERZER
 100  CONTINUE
C USER DEPENDENT SPARE FLAGS:
      DO 200 ISPR = 1, MKBMX2
          ISPARK(ISPR, NPFLKA) = 0
 200  CONTINUE
C SAVE THE TRACK NUMBER OF THE STACK PARTICLE:
      ISPARK(MKBMX2,NPFLKA) = NPFLKA
      NPARMA = NPARMA + 1
      NUMPAR(NPFLKA) = NPARMA
      NEVENT(NPFLKA) = 0
      DFNEAR(NPFLKA) = +ZERZER

C ====< TO HERE >====

C PARTICLE AGE (S)
      AGESTK(NPFLKA) = +ZERZER
      AKNSHR(NPFLKA) = -TWOTWO

C ====< ARMSTRONG FLUX >====
C DEFINED IN MEV
      EMIN = TENTEN
      EMAX = FIVFIV*GEVMEV

C RANDOM ENERGY IN [EMIN,EMAX)
      RANDE = (EMAX - EMIN)*FLRNDM(DUMMY) + EMIN
      TKEFLK(NPFLKA) = RANDE*EMVGEV
      PMOFLK(NPFLKA) = SQRT(RANDE*EMVGEV * (RANDE*EMVGEV
     +                          + TWOTWO*AM(IONID)))

C NEUTRON PARAMETERS
      PHIZ1 = -4.7959
      PHIZ2 = -5.301
      SLOP1 = -0.50515
      SLOP2 = -1.7696

      NPARAM1 = TENTEN**(PHIZ1 - SLOP1)
      NPARAM2 = TENTEN**(PHIZ2 - TWOTWO*SLOP2)

C PROTON PARAMETERS
      P2FAC = 5E-7
      PFAC2SL = 0.76956
      PFAC2INT = -6.301

      PPARAM = TENTEN**(PFAC2INT - TWOTWO*PFAC2SL)

C DEFAULT: IGNORE UNDEFINED PARTICLES AND RANGES
      COSSPC = ZERZER

C NEUTRON
      IF (IJBEAM .EQ. 8) THEN
          IF (10.0 .LE. RANDE .AND. RANDE .LE. 100.0) THEN
              COSSPC = NPARAM1 * RANDE**SLOP1
          ELSEIF (100.0 .LT. RANDE) THEN
              COSSPC = NPARAM2 * RANDE**SLOP2
          ENDIF
C PROTON
      ELSEIF (IJBEAM .EQ. 1) THEN
          IF (10.0 .LE. RANDE .AND. RANDE .LE. 100.0) THEN
              COSSPC = P2FAC
          ELSEIF (100.0 .LT. RANDE .AND. RANDE .LE. 1000.0) THEN
              COSSPC = PPARAM * RANDE**PFAC2SL
          ELSEIF (1000.0 .LT. RANDE) THEN
              COSSPC = NPARAM2 * RANDE**SLOP2
          ENDIF
      ENDIF

C WEIGHT OF THE SOURCE PARTICLE
      WTFLK(NPFLKA) = COSSPC
      WEIPRI = WEIPRI + WTFLK(NPFLKA)
C DIRECTION COSINES OF THE SOURCE PARTICLE
      TXFLK(NPFLKA) = UBEAM
      TYFLK(NPFLKA) = VBEAM
      TZFLK(NPFLKA) = WBEAM
C POLARISATION OF THE SOURCE PARTICLE
      TXPOL(NPFLKA) = -TWOTWO
      TYPOL(NPFLKA) = +ZERZER
      TZPOL(NPFLKA) = +ZERZER
C POSITION OF THE SOURCE PARTICLE
      XFLK(NPFLKA) = XBEAM
      YFLK(NPFLKA) = YBEAM
      ZFLK(NPFLKA) = ZBEAM

C ====< DO NOT CHANGE FROM HERE >====
C CALCULATE TOTAL KINETIC ENERGY OF THE PRIMARIES
      IF (ILOFLK(NPFLKA) .EQ. -2 .OR. ILOFLK(NPFLKA) .GT. 100000) THEN
          TKESUM = TKESUM + TKEFLK(NPFLKA) + AMDISC(ILOFLK(NPFLKA))
      ELSEIF (ILOFLK(NPFLKA) .NE. 0) THEN
          TKESUM = TKESUM + (TKEFLK(NPFLKA)
     +                 + AMDISC(ILOFLK(NPFLKA))) * WTFLK(NPFLKA)
      ELSE
          TKESUM = TKESUM + TKEFLK(NPFLKA) * WTFLK(NPFLKA)
      ENDIF
      RADDLY(NPFLKA) = ZERZER
C ====< TO HERE >====

C THE FOLLOWING LINES MAKES THE STARTING REGION SEARCH MUCH MORE
C ROBUST IF PARTICLES ARE STARTING VERY CLOSE TO A BOUNDARY:
      CALL GEOCRS(TXFLK(NPFLKA), TYFLK(NPFLKA), TZFLK(NPFLKA))
      CALL GEOREG(XFLK(NPFLKA), YFLK(NPFLKA), ZFLK(NPFLKA),
     +                NRGFLK(NPFLKA), IDISC)

C ====< DO NOT CHANGE FROM HERE >====
       CALL GEOHSM(NHSPNT(NPFLKA), 1, -11, MLATTC)
       NLATTC(NPFLKA) = MLATTC
       CMPATH(NPFLKA) = ZERZER
       CALL SOEVSV
C ====< TO HERE >====

      RETURN
      END
